
///////////////////////////////////////////////////////////////////////////////
//
//	map_export.cpp
//

#include <windows.h>
#include "window.h"


int ExpandData(unsigned char *buf, unsigned int buf_size, const unsigned char *buf_src);

///////////////////////////////////////////////////////////////////////////////

struct CMPHeader{
    unsigned char byte[4];
    unsigned short word[17];
};


int ExpandData(
	unsigned char *buf,
	unsigned int buf_size,
	const unsigned char *buf_src)
{

    unsigned int cbuf = 0;  // obt@̃JE^
    unsigned int s4 = 0;    // 4bitꂽԂ̂Ƃ1
    unsigned int s4d;       // 4bitꂽԂ̂ƂAߏɓǂݏo4biti[

    unsigned int byte;
    unsigned int sz;
    unsigned int dt;
    unsigned int i;

	CMPHeader cmp_header;
	buf_src++;
	memcpy_s(&cmp_header, sizeof cmp_header, buf_src, sizeof cmp_header);
	buf_src += sizeof cmp_header;

    while (1){

        // 4bitĂ邩ǂŕ
        if (s4){
            // ĂƂ : s4d̒lŔf
            switch (s4d){
                case 0x0:       // 0X : ROMXoCgRs[B00̏ꍇIB꒼ȂB
                    byte = *buf_src++;                         // 1byteǂ
                    if ((sz = (byte & 0xf0) >> 4) == 0){
                        return cbuf;                            // I(4bit͖)
                    }else{
                        if (cbuf + sz > buf_size){              // I[o[t[
                            return -1;
                        }
                        for (i=0; i<sz; i++){
                            dt = *buf_src++;                   // 1byteǂ
                            byte = ((byte&0x0f)<<4)|((dt&0xf0)>>4); // ݂̉4bitƎ̏4bitA
                            buf[cbuf++] = byte;                 // A8bit
                            byte = dt;                          // ւ
                        }
                        s4d = byte & 0x0f;                      // ꒼Ȃ(4bitɎz)
                    }
                    break;
                case 0x1:       // 1XX : XX(8bit)͂B꒼B
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    buf[cbuf++] = *buf_src++;                  // 1byte(XX)ǂݏ
                    s4=0;                                       // ꒼
                    break;
                case 0x2:       // 2XXYY : XX YY(16bit)͂B꒼B
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    buf[cbuf++] = *buf_src++;                  // 1byte(XX)ǂݏ
                    buf[cbuf++] = *buf_src++;                  // 1byte(YY)ǂݏ
                    s4=0;                                       // ꒼
                    break;
                case 0x3:       // 3XYY : YY(8bit)(X+3)͂B꒼ȂB
                    dt = *buf_src++;                           // 1byteǂ
                    sz = ((dt & 0xf0) >> 4) + 3;                // 񐔂̌vZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // 1byteǂ
                    dt = ((dt&0x0f) << 4) | ((byte&0xf0) >> 4); // 8bitɌ
                    for (i=0; i<sz; i++) buf[cbuf++] = dt;      // dtsz񏑂
                    s4d = byte & 0x0f;                          // ꒼Ȃ
                    break;
                case 0x4:       // 4X : cmp_header.byte[0] (8bit)(X+3)񏑂݁B꒼ȂB
                    byte = *buf_src++;                         // 1byteǂ
                    sz = ((byte & 0xf0) >> 4) + 3;              // 񐔂̌vZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    for (i=0; i<sz; i++) buf[cbuf++] = cmp_header.byte[0];
                    s4d = byte & 0x0f;                          // 8bitf[^sz񏑂݁A꒼Ȃ
                    break;
                case 0x5:       // 5X : cmp_header.byte[1] (8bit)(X+3)񏑂݁B꒼ȂB
                    byte = *buf_src++;                         // 1byteǂ
                    sz = ((byte & 0xf0) >> 4) + 3;              // 񐔂̌vZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    for (i=0; i<sz; i++) buf[cbuf++] = cmp_header.byte[1];
                    s4d = byte & 0x0f;                          // 8bitf[^sz񏑂, ꒼Ȃ
                    break;
                case 0x6:       // 6 : cmp_header.word[0] (16bit)1񏑂݁B꒼B
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    *(unsigned short*)(buf+cbuf) = cmp_header.word[0];
                    cbuf+=2;                                    // 16bitRs[
                    s4=0;                                       // ꒼
                    break;
                case 0x7:       // 7 : cmp_header.byte[2] (8bit)1񏑂݁B꒼B
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    buf[cbuf++] = cmp_header.byte[2];          // 8bitRs[
                    s4=0;                                       // ꒼
                    break;
                case 0x8:       // 8 : cmp_header.byte[3] (8bit)1񏑂݁B꒼B
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    buf[cbuf++] = cmp_header.byte[3];          // 8bitRs[
                    s4=0;                                       // ꒼
                    break;
                case 0x9:       // 9X : (X+2)oCgO2oCgRs[B꒼ȂB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // 1byteǂ
                    dt = ((byte & 0xf0) >> 4) + 2;              // ʒuvZ
                    if (cbuf<dt || dt<2){                       // sȈʒu
                        return -1;
                    }
                    *(unsigned short*)(buf+cbuf) = *(unsigned short*)(buf+cbuf-dt);
                    cbuf+=2;                                    // 16bitRs[
                    s4d = byte & 0x0f;                          // ꒼Ȃ
                    break;
                case 0xA:       // AXYY : {(X+3)+YY}oCgO(X+3)oCgRs[B꒼ȂB
                    dt = *buf_src++;                           // 1byte
                    sz = ((dt & 0xf0) >> 4) + 3;                // TCYvZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // Ɏ1byte
                    dt = ((dt&0x0f) << 4) | ((byte&0xf0) >> 4); // YY8bitɌ
                    dt += sz;                                   // X+3𑫂Ĉʒum
                    if (cbuf<dt || sz>dt){                      // ʒu܂̓TCYs
                        return -1;
                    }
                    memcpy(buf+cbuf, buf+cbuf-dt, sz);          // Rs[
                    cbuf += sz;
                    s4d = byte & 0x0f;                          // ꒼Ȃ
                    break;
                case 0xB:       // BXYYZ : (YYZ + 103h)oCgO(X+3)oCgRs[B꒼B
                    dt = *buf_src++;                           // 1byte
                    sz = ((dt & 0xf0) >> 4) + 3;                // TCYvZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // Ɏ1byte
                    dt = (((dt&0x0f)<<8) | byte) + 0x103;       // ʒuvZ
                    if (cbuf<dt || sz>dt){                      // ʒu܂̓TCYs
                        return -1;
                    }
                    memcpy(buf+cbuf, buf+cbuf-dt, sz);          // Rs[
                    cbuf += sz;
                    s4 = 0;                                     // ꒼
                    break;
                case 0xC:       // CXYYZZ : YYZZ(BigEndian)oCgO(X+3)oCgRs[B꒼ȂB
                    dt = *buf_src++;                           // 1byte(XY)
                    sz = ((dt & 0xf0) >> 4) + 3;                // TCYvZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // 1byte(YZ)
                    dt = ((dt & 0x0f) << 8) | byte;             // ܂YYZ߂
                    byte = *buf_src++;                         // Ɏ1byte(Z*)
                    dt = (dt << 4) | ((byte & 0xf0) >> 4);      // ʒům(YYZZ)
                    if (cbuf<dt || sz>dt){                      // ʒu܂̓TCYs
                        return -1;
                    }
                    memcpy(buf+cbuf, buf+cbuf-dt, sz);          // Rs[
                    cbuf += sz;
                    s4d = byte & 0x0f;                          // ꒼Ȃ
                    break;
                case 0xD:       // D : 1oCgO1oCgRs[B꒼B
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    if (cbuf == 0){                             // ʒus
                        return -1;
                    }
                    buf[cbuf] = buf[cbuf-1];                    // 8bitRs[
                    cbuf++; s4=0;                               // ꒼
                    break;
                case 0xE:       // E : 2oCgO2oCgRs[B꒼B
                    if (cbuf + 2 > buf_size){                  // I[o[t[
                        return -1;
                    }
                    if (cbuf < 2){                              // ʒus
                        return -1;
                    }
                    *(unsigned short*)(buf+cbuf) = *(unsigned short*)(buf+cbuf-2);
                    cbuf+=2; s4=0;                              // 16bitRs[, ꒼
                    break;
                case 0xF:       // FX : cmp_header.word[X+1] (16bit)݁B꒼ȂB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // 1byte
                    dt = ((byte & 0xf0) >> 4) + 1;              // ԍvZ
                    *(unsigned short*)(buf+cbuf) = cmp_header.word[dt];
                    cbuf+=2; s4d = byte & 0x0f;                 // 16bitRs[, ꒼Ȃ
                    break;
            }
        }else{

            // ĂȂƂ : ܂1byteǂ݂B̏4bitŔf
            byte = *buf_src++;

            switch ((byte & 0xf0) >> 4){
                case 0x0:       // 0X : ROMXoCgRs[B00̏ꍇIBȂB
                    if ((sz = byte & 0x0f) == 0x0){
                        return cbuf;                            // I
                    }else{
                        if (cbuf + sz > buf_size){              // I[o[t[
                            return -1;
                        }
						memcpy(buf+cbuf, buf_src, sz);          // szoCgǂݍ
						buf_src += sz;
                        cbuf += sz;                             // ĂȂ܂܃^[Gh
                    }
                    break;
                case 0x1:       // 1XX : XX(8bit)͂BB
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    dt = (byte & 0x0f) << 4;                    // 4bit
                    byte = *buf_src++;                         // 1byteǂ
                    dt |= (byte & 0xf0) >> 4;                   // 4bit
                    buf[cbuf++] = dt;                           // 8bit
                    s4=1, s4d = byte & 0x0f;                    // 4bit
                    break;
                case 0x2:       // 2XXYY : XX YY(16bit)͂BB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    dt = (byte & 0x0f) << 4;                    // 4bit
                    byte = *buf_src++;                         // 1byteǂ
                    dt |= (byte & 0xf0) >> 4;                   // 4bit
                    buf[cbuf++] = dt;                           // 1byteڂ
                    dt = (byte & 0x0f) << 4;                    // 4bit
                    byte = *buf_src++;                         // 1byteǂ
                    dt |= (byte & 0xf0) >> 4;                   // 4bit
                    buf[cbuf++] = dt;                           // 2byteڂ
                    s4=1, s4d = byte & 0x0f;                    // 4bit
                    break;
                case 0x3:       // 3XYY : YY (8bit)(X+3)͂BȂB
                    sz = (byte & 0x0f) + 3;                     // 񐔌vZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // 1byteǂ(YY)
                    for (i=0; i<sz; i++) buf[cbuf++] = byte;    // bytesz񏑂
                    break;
                case 0x4:       // 4X : cmp_header.byte[0] (8bit)(X+3)͂BȂB
                    sz = (byte & 0x0f) + 3;                     // 񐔌vZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    for (i=0; i<sz; i++)
                        buf[cbuf++] = cmp_header.byte[0];      // 8bitf[^sz񏑂
                    break;
                case 0x5:       // 5X : cmp_header.byte[1] (8bit)(X+3)͂BȂB
                    sz = (byte & 0x0f) + 3;                     // 񐔌vZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    for (i=0; i<sz; i++)
                        buf[cbuf++] = cmp_header.byte[1];      // 8bitf[^sz񏑂
                    break;
                case 0x6:       // 6 : cmp_header.word[0] (16bit)1͂BB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    *(unsigned short*)(buf+cbuf) = cmp_header.word[0];
                    cbuf += 2;                                  // 16bitRs[
                    s4=1, s4d = byte & 0x0f;                    // 4bit
                    break;
                case 0x7:       // 7 : cmp_header.byte[2] (8bit)1͂BB
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    buf[cbuf++] = cmp_header.byte[2];          // ̂܂8bit
                    s4=1, s4d = byte & 0x0f;                    // 4bit
                    break;
                case 0x8:       // 8 : cmp_header.byte[3] (8bit)1͂BB
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    buf[cbuf++] = cmp_header.byte[3];          // ̂܂8bit
                    s4=1, s4d = byte & 0x0f;                    // 4bit
                    break;
                case 0x9:       // 9X : (X+2)oCgO2oCgRs[BȂB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    dt = (byte & 0x0f) + 2;                     // ʒuvZ
                    if (cbuf<dt || dt<2){                       // ʒus
                        return -1;
                    }
                    *(unsigned short*)(buf+cbuf) = *(unsigned short*)(buf+cbuf-dt);
                    cbuf += 2;                                  // 16bitRs[
                    break;
                case 0xA:       // AXYY : {(X+3)+YY}oCgO(X+3)oCgRs[BȂB
                    sz = (byte & 0x0f) + 3;                     // TCYvZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    byte = *buf_src++;                         // 1byteǂ(YY)
                    dt = sz + byte;                             // ʒum
                    if (cbuf<dt){                               // ʒus(dt<sz̃`FbN͕sv)
                        return -1;
                    }
                    memcpy(buf+cbuf, buf+cbuf-dt, sz);          // Rs[s
                    cbuf += sz;
                    break;
                case 0xB:       // BXYYZ : (YYZ+103h)oCgO(X+3)oCgRs[BB
                    sz = (byte & 0x0f) + 3;                     // TCYvZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    dt = *buf_src++;                           // 1byteǂ(YY)
                    byte = *buf_src++;                         // 1byteǂ(Z)
                    dt = ((dt<<4)|((byte&0xf0)>>4))+0x103;      // ʒuvZ
                    if (cbuf<dt || sz>dt){                      // ʒu܂̓TCYs
                        return -1;
                    }
                    memcpy(buf+cbuf, buf+cbuf-dt, sz);          // Rs[s
                    cbuf += sz;
                    s4=1, s4d = byte & 0x0f;                    // 4bit
                    break;
                case 0xC:       // CXYYZZ : YYZZ(BigEndian)oCgO(X+3)oCgRs[BȂB
                    sz = (byte & 0x0f) + 3;                     // TCYvZ
                    if (cbuf + sz > buf_size){                  // I[o[t[
                        return -1;
                    }
                    dt = *buf_src++; byte = *buf_src++;       // 2byteǂ(YY, ZZ)
                    dt = (dt << 8) | byte;                      // BigEndianŌ
                    if (cbuf<dt || sz>dt){                      // ʒu܂̓TCYs
                        return -1;
                    }
                    memcpy(buf+cbuf, buf+cbuf-dt, sz);          // Rs[s
                    cbuf += sz;
                    break;
                case 0xD:       // D : 1byteO1byteRs[BB
                    if (cbuf + 1 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    if (cbuf == 0){                             // ʒus
                        return -1;
                    }
                    buf[cbuf] = buf[cbuf-1];                    // 8bitRs[
                    cbuf++; s4=1, s4d = byte & 0x0f;            // 4bit
                    break;
                case 0xE:       // E : 2byteO2byteRs[BB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    if (cbuf < 2){                              // ʒus
                        return -1;
                    }
                    *(unsigned short*)(buf+cbuf) = *(unsigned short*)(buf+cbuf-2);
                    cbuf+=2; s4=1, s4d = byte & 0x0f;           // 16bitRs[, 4bit
                    break;
                case 0xF:       // FX : cmp_header.word[X+1] (16bit)݁BȂB
                    if (cbuf + 2 > buf_size){                   // I[o[t[
                        return -1;
                    }
                    dt = (byte & 0x0f) + 1;                     // ԍ擾
                    *(unsigned short*)(buf+cbuf) = cmp_header.word[dt];
                    cbuf += 2;                                  // 16bitRs[
                    break;
            }
        }
    }
    
    return -1;

}













