
///////////////////////////////////////////////////////////////////////////////
//
//	gdi.cpp
//

#include "gdi.h"


void BitmapBuffer::destroy(){
	if (!bValid) return;
	DeleteDC(hdc);
	DeleteObject(hbm);
	bValid = FALSE;
	return;
}


BOOL BitmapBuffer::create(HDC hdc_cmp, int cx, int cy){
	if (bValid) destroy();
	hdc = CreateCompatibleDC(hdc_cmp);
	if (hdc == NULL){
		return FALSE;
	}
	hbm = CreateCompatibleBitmap(hdc_cmp, cx, cy);
	if (hbm == NULL){
		DeleteDC(hdc);
		return FALSE;
	}
	SelectObject(hdc, hbm);
	bValid = TRUE;
	return TRUE;
}

BOOL BitmapBuffer::create_and_load(HDC hdc_cmp, LPCSTR filename){
	if (bValid) destroy();
	hdc = CreateCompatibleDC(hdc_cmp);
	if (hdc == NULL){
		return FALSE;
	}
	hbm = (HBITMAP)LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	SelectObject(hdc, hbm);
	bValid = TRUE;
	return TRUE;
}

BitmapBuffer::BitmapBuffer(){
	bValid = FALSE;
}

BitmapBuffer::BitmapBuffer(HDC hdc_cmp, int cx, int cy){
	bValid = FALSE;
	create(hdc_cmp, cx, cy);
}

BitmapBuffer::~BitmapBuffer(){
	if (bValid) destroy();
}

HGDIOBJ BitmapBuffer::select_object(HGDIOBJ hObj){
	return SelectObject(hdc, hObj);
}



BOOL BitmapBuffer::rectangle(int left, int top, int right, int bottom){
	return Rectangle(hdc, left, top, right, bottom);
}





