
///////////////////////////////////////////////////////////////////////////////
//
//	level_banum.cpp
//

#include <stdio.h>
#include "id.h"
#include "project.h"



//=================================================================================================



LevelBananaApply_UndoMethod::LevelBananaApply_UndoMethod(
	ProjectManager *_project_manager,
	LevelManager *_level_manager,
	LevelBananasManager *_bananas_manager,
	int _level_num, int _banana_num,
	const BananaAllocData *_data_before,
	const BananaAllocData *_data_after
	)
	: project_manager(_project_manager), level_manager(_level_manager), bananas_manager(_bananas_manager),
	level_num(_level_num), banana_num(_banana_num), data_before(*_data_before), data_after(*_data_after)
{
}


LevelBananaApply_UndoMethod::~LevelBananaApply_UndoMethod(){}

void LevelBananaApply_UndoMethod::method_in_level(bool bUndo){
	char s[128], s2[128];
	level_manager->select_page(LEVEL_BANANAS);
	level_manager->excluse_pages(LEVEL_BANANAS);
	LevelBananasData::iterator i = bananas_manager->get_iterator(banana_num);
	*i = (bUndo ? data_before : data_after);
	LADRS adrs_levels = bananas_manager->get_banana_levels_adrs();
	SADRS adrs_bananas = adrs_levels.adrs + project_manager->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i).store_data(project_manager, adrs_levels.bank, adrs_bananas + banana_num*BananaAllocData::size, level_manager->get_code());
	HWND hwList = GetDlgItem(bananas_manager->hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)banana_num, 0);
	bananas_manager->get_banana_text(s, sizeof s, &*i);
	sprintf_s(s2, sizeof s2, "#%d: %s", banana_num, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)banana_num, (LPARAM)s2);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)banana_num, 0);
	bananas_manager->output_banana_data(&*i, banana_num);
	bananas_manager->focus_on_banana(banana_num);
	return;
}

void LevelBananaApply_UndoMethod::method_out_of_level(bool bUndo){
	level_manager->load_level(level_num);
	method_in_level(bUndo);
	return;
}


void LevelBananaApply_UndoMethod::undo(){
	if (level_manager->get_level_num() == level_num){
		method_in_level(true);
	}else{
		method_out_of_level(true);
	}
}

void LevelBananaApply_UndoMethod::redo(){
	if (level_manager->get_level_num() == level_num){
		method_in_level(false);
	}else{
		method_out_of_level(false);
	}
}


//=================================================================================================

LevelBananaUpDown_UndoMethod::LevelBananaUpDown_UndoMethod(
	ProjectManager *_project_manager,
	LevelManager *_level_manager,
	LevelBananasManager *_bananas_manager,
	int _level_num,
	int _banana_former
	)
	: project_manager(_project_manager), level_manager(_level_manager), bananas_manager(_bananas_manager),
	level_num(_level_num), banana_former(_banana_former), banana_latter(_banana_former+1)
{
}

LevelBananaUpDown_UndoMethod::~LevelBananaUpDown_UndoMethod(){}

void LevelBananaUpDown_UndoMethod::method(bool bUp){
	if (level_manager->get_level_num() == level_num){
		method_in_level(bUp);
	}else{
		method_out_of_level(bUp);
	}
	return;
}

void LevelBananaUpDown_UndoMethod::method_in_level(bool bUp){
	char s[256], s2[128];
	level_manager->select_page(LEVEL_BANANAS);
	level_manager->excluse_pages(LEVEL_BANANAS);
	LevelBananasData::iterator i_former = bananas_manager->get_iterator(banana_former);
	LevelBananasData::iterator i_latter = bananas_manager->get_iterator(banana_latter);
	HWND hwList = GetDlgItem(bananas_manager->get_hWnd(), IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)banana_latter, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)banana_former, 0);
	BananaAllocData data_temp = *i_former;
	*i_former = *i_latter;
	*i_latter = data_temp;
	bananas_manager->get_banana_text(s2, sizeof s2, &*i_former);
	sprintf_s(s, sizeof s, "#%d: %s", banana_former, s2);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)banana_former, (LPARAM)s);
	bananas_manager->get_banana_text(s2, sizeof s2, &*i_latter);
	sprintf_s(s, sizeof s, "#%d: %s", banana_latter, s2);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)banana_latter, (LPARAM)s);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	int banana_num = bUp ? banana_former : banana_latter;
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)banana_num, 0);
	bananas_manager->output_banana_data(&*(bUp ? i_former : i_latter), banana_num);
	// ROMɔf
	LADRS adrs_levels = bananas_manager->get_banana_levels_adrs();
	SADRS adrs_bananas = adrs_levels.adrs + project_manager->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	SADRS adrs_former = adrs_bananas + banana_former*BananaAllocData::size;
	SADRS adrs_latter = adrs_bananas + banana_latter*BananaAllocData::size;
	(*i_former).store_data(project_manager, adrs_levels.bank, adrs_former, level_manager->get_code());
	(*i_latter).store_data(project_manager, adrs_levels.bank, adrs_latter, level_manager->get_code());
	bananas_manager->focus_on_banana(banana_num);
	return;
}

void LevelBananaUpDown_UndoMethod::method_out_of_level(bool bUp){
	level_manager->load_level(level_num);
	method_in_level(bUp);
	return;
}


//-------------------------------------------------------------------------------------------------

LevelBananaUp_UndoMethod::LevelBananaUp_UndoMethod(
	ProjectManager *_project_manager, LevelManager *_level_manager,
	LevelBananasManager *_bananas_manager, int _level_num, int _banana_num)
	: LevelBananaUpDown_UndoMethod(_project_manager, _level_manager, _bananas_manager,
	_level_num, _banana_num-1)
{
}

LevelBananaUp_UndoMethod::~LevelBananaUp_UndoMethod(){}


void LevelBananaUp_UndoMethod::undo(){
	method(false);
}

void LevelBananaUp_UndoMethod::redo(){
	method(true);
}


//-------------------------------------------------------------------------------------------------

LevelBananaDown_UndoMethod::LevelBananaDown_UndoMethod(
	ProjectManager *_project_manager, LevelManager *_level_manager,
	LevelBananasManager *_bananas_manager, int _level_num, int _banana_num)
	: LevelBananaUpDown_UndoMethod(_project_manager, _level_manager, _bananas_manager,
	_level_num, _banana_num)
{
}

LevelBananaDown_UndoMethod::~LevelBananaDown_UndoMethod(){}


void LevelBananaDown_UndoMethod::undo(){
	method(true);
}

void LevelBananaDown_UndoMethod::redo(){
	method(false);
}



//=================================================================================================


LevelBananaSort_UndoMethod::LevelBananaSort_UndoMethod(
	ProjectManager *_project_manager,
	LevelManager *_level_manager,
	LevelBananasManager *_bananas_manager,
	int _level_num,
	int _banana_before,
	int _banana_after,
	const LevelBananasData &_data_before,
	const LevelBananasData &_data_after
	)
	: project_manager(_project_manager), level_manager(_level_manager), bananas_manager(_bananas_manager),
	level_num(_level_num), banana_before(_banana_before), banana_after(_banana_after),
	data_before(_data_before), data_after(_data_after)
{
}

LevelBananaSort_UndoMethod::~LevelBananaSort_UndoMethod(){}

void LevelBananaSort_UndoMethod::undo(){
	if (level_manager->get_level_num() == level_num){
		method_in_level(true);
	}else{
		method_out_of_level(true);
	}
}

void LevelBananaSort_UndoMethod::redo(){
	if (level_manager->get_level_num() == level_num){
		method_in_level(false);
	}else{
		method_out_of_level(false);
	}
}


void LevelBananaSort_UndoMethod::method_in_level(bool bUndo){
	int n;
	char s[256], s2[256];
	level_manager->select_page(LEVEL_BANANAS);
	level_manager->excluse_pages(LEVEL_BANANAS);
	LevelBananasData::iterator i, i_end;
	HWND hwList = GetDlgItem(bananas_manager->get_hWnd(), IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	for (i=bananas_manager->data.begin(), i_end=bananas_manager->data.end(); i!=i_end; i++){
		SendMessage(hwList, LB_DELETESTRING, (WPARAM)0, 0);
	}
	bananas_manager->data = bUndo ? data_before : data_after;
	for (i=bananas_manager->data.begin(), i_end=bananas_manager->data.end(), n=0; i!=i_end; i++, n++){
		bananas_manager->get_banana_text(s2, sizeof s2, &(*i));
		sprintf_s(s, sizeof s, "#%d: %s", n, s2);
		SendMessage(hwList, LB_INSERTSTRING, (WPARAM)n, (LPARAM)s);
	}
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	int banana_num = bUndo ? banana_before : banana_after;
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)banana_num, 0);
	bananas_manager->sel_changed(banana_num);
	// ROMɔf
	LADRS adrs_levels = bananas_manager->get_banana_levels_adrs();
	bananas_manager->data.store_data(project_manager, adrs_levels.bank, adrs_levels.adrs, level_num, level_manager->get_code());
	bananas_manager->focus_on_banana(banana_num);
	return;
}

void LevelBananaSort_UndoMethod::method_out_of_level(bool bUndo){
	level_manager->load_level(level_num);
	method_in_level(bUndo);
	return;
}

