
///////////////////////////////////////////////////////////////////////////////
//
//	level_insp.cpp
//

#include <stdio.h>
#include "project.h"
#include <commctrl.h>


LPCSTR LevelEditInspector::pAppName   = "Inspector";
LPCSTR LevelEditInspector::pClassName = "sdk2ed_insp";

BOOL LevelEditInspector::Init(){
	if (!register_class_ex(
		CS_HREDRAW | CS_VREDRAW | CS_NOCLOSE,
		(HICON)NULL,
		(HICON)NULL,
		LoadCursor(NULL, IDC_ARROW),
		(HBRUSH)(COLOR_3DFACE + 1),
		pClassName,
		NULL
		)
	){
		return FALSE;
	}
	return TRUE;
}


LevelEditInspector::LevelEditInspector(ProjectManager *_pwFrame)
: pwFrame(_pwFrame)
{
	pages = NULL;
	nPages = 0;
}

LevelEditInspector::~LevelEditInspector(){
	if (pages) delete[] pages;
}

BOOL LevelEditInspector::create(TabPage *(_pages[]), int _nPages){
	if (!create_window_ex(pClassName, "",
		WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_CLIPCHILDREN,
		WS_EX_TOOLWINDOW,//WS_EX_PALETTEWINDOW,
		0, 0, 0, 0,
		pwFrame
		)
	){
		return FALSE;
	}
	hwTab = CreateWindowEx(0, WC_TABCONTROL, "",
		WS_CHILD | WS_VISIBLE// | WS_CLIPCHILDREN
		//,
		| TCS_FOCUSNEVER,
		//| TCS_BUTTONS | TCS_FLATBUTTONS | TCS_FOCUSNEVER | TCS_HOTTRACK,
		0, 0, 0, 0, hWnd, NULL, hInst, NULL);
	//TabCtrl_SetExtendedStyle(hwTab, TabCtrl_GetExtendedStyle(hwTab) & (~TCS_EX_FLATSEPARATORS));
	SendMessage(hwTab, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)FALSE);
	int x, y, w=100, h=100;
	if (nPages = _nPages){
		char s[64];
		TC_ITEM tci;
		tci.mask	= TCIF_TEXT;
		tci.pszText	= s;
		pages = new TabPage*[nPages];
		for (int i=0; i<nPages; i++){
			pages[i] = _pages[i];
			pages[i]->create(hwTab);
			strcpy_s(s, sizeof s, pages[i]->get_text());
			SendMessage(hwTab, TCM_INSERTITEM, (WPARAM)i, (LPARAM)&tci);
		}
		RECT rt, rt2;
		GetWindowRect(pages[0]->get_hWnd(), &rt);		// _CAÕTCY߂(Œl)
		rt.right -= rt.left;	rt.left = 0;
		rt.bottom -= rt.top;	rt.top = 0;
		rt2 = rt;
		TabCtrl_AdjustRect(hwTab, TRUE, &rt);			// Kvȃ^ũTCY߂
		for (int i=0; i<nPages; i++){
			pages[i]->move(-rt.left, -rt.top, rt2.right, rt2.bottom, FALSE);
		}
		rt.right -= rt.left;	rt.left = 0;
		rt.bottom -= rt.top;	rt.top = 0;
		MoveWindow(hwTab, 0, 0, rt.right, rt.bottom, FALSE);
		AdjustWindowRectEx(&rt, (DWORD)GetWindowLong(hWnd, GWL_STYLE),
			FALSE, (DWORD)GetWindowLong(hWnd, GWL_EXSTYLE));	// KvȃEBhẼTCY(ry
		w = rt.right - rt.left;
		h = rt.bottom - rt.top;
		page_changed(0);
	}
	x = GetPrivateProfileInt(pAppName, "Pos_X", CW_USEDEFAULT, ConfigFileName);
	y = GetPrivateProfileInt(pAppName, "Pos_Y", CW_USEDEFAULT, ConfigFileName);
	if ((x == CW_USEDEFAULT || y == CW_USEDEFAULT)){
		x = y = 0;
	}
	MoveWindow(hWnd, x, y, w, h, FALSE);
	ShowWindow(hWnd, SW_SHOWNORMAL);
	return TRUE;
}

void LevelEditInspector::page_changed(int page){
	for (int i=0; i<nPages; i++){
		ShowWindow(pages[i]->get_hWnd(), page==i ? SW_SHOW : SW_HIDE);
	}
	return;
}

void LevelEditInspector::select_page(int page){
	TabCtrl_SetCurSel(hwTab, page);
	page_changed(page);
	return;
}

void LevelEditInspector::save_config(){
	RECT rt;
	char s[16];
	GetWindowRect(hWnd, &rt);
	sprintf_s(s, sizeof s, "%d", rt.left);
	WritePrivateProfileString(pAppName, "Pos_X", s, ConfigFileName);
	sprintf_s(s, sizeof s, "%d", rt.top);
	WritePrivateProfileString(pAppName, "Pos_Y", s, ConfigFileName);
	destroy();
	return;
}

LRESULT LevelEditInspector::Proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg){
		case WM_CREATE:
			return 0;
		case WM_ACTIVATE:
			//if (LOWORD(wParam) == WA_INACTIVE && (HWND)lParam == pwFrame->get_hWnd()) break;
			pwFrame->nc_activate(wParam);
			break;
		case WM_NOTIFY:
			if (((NMHDR*)lParam)->code == TCN_SELCHANGE){
				page_changed(TabCtrl_GetCurSel(hwTab));
				return 0;
			}
			break;
		case WM_DESTROY:
			save_config();
			return 0;
	}
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

void LevelEditInspector::nc_activate(WPARAM wParam){
	SetWindowPos(hWnd, HWND_TOP, 0, 0, 0, 0,
		SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	//DefWindowProc(hWnd, WM_NCACTIVATE, wParam, 0);
	return;
}
















