
///////////////////////////////////////////////////////////////////////////////
//
//	scrbar.h
//

#ifndef _SCRBAR_
#define _SCRBAR_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <commctrl.h>
#include "window.h"



class WindowWithHScrollBar : virtual public Window{
	SCROLLINFO si;
	UINT line_size;
	bool bDisableNoScroll;
	bool bRedraw;
	virtual void scrolled_h(int nNewPos, UINT nNewPage, int nOldPos, UINT nOldPage);
public:
	WindowWithHScrollBar();
	~WindowWithHScrollBar();
	void set_disable_no_Scroll_h(bool _bDisableNoScroll);
	void set_redraw_h(bool _bRedraw);
	void set_range_h(int nMin, int nMax);
	void set_page_size_h(UINT nPage);
	void set_line_size_h(UINT nLineSize);
	void set_position_h(int nPos);
	void resize_h(UINT nPage);
	void handle_message_h(WPARAM wParam, LPARAM lParam);
	void scroll_h(int dx);
	int get_pos_h() const;
	UINT get_page_h() const;
};


class WindowWithVScrollBar : virtual public Window{
	SCROLLINFO si;
	UINT line_size;
	bool bDisableNoScroll;
	bool bRedraw;
	virtual void scrolled_v(int nNewPos, UINT nNewPage, int nOldPos, UINT nOldPage);
public:
	WindowWithVScrollBar();
	~WindowWithVScrollBar();
	void set_disable_no_Scroll_v(bool _bDisableNoScroll);
	void set_redraw_v(bool _bRedraw);
	void set_range_v(int nMin, int nMax);
	void set_page_size_v(UINT nPage);
	void set_line_size_v(UINT nLineSize);
	void set_position_v(int nPos);
	void resize_v(UINT nPage);
	void handle_message_v(WPARAM wParam, LPARAM lParam);
	void scroll_v(int dy);
	int get_pos_v() const;
	UINT get_page_v() const;
};


class WindowWithBothScrollBars : public WindowWithHScrollBar, public WindowWithVScrollBar{
};



//-------------------------------------------------------------------------------

class MButtonPan : public UI_Base{

	enum PanDirection{
		PAN_HORZ=1,
		PAN_VERT,
		PAN_BOTH
	} direction;
	union{
		WindowWithHScrollBar *pWnd_h;
		WindowWithVScrollBar *pWnd_v;
		WindowWithBothScrollBars *pWnd_both;
	} window;
	Window *pWnd;
	DWORD dwPeriod, dwID;
	POINT cursor_p;
	bool bEnabled;
	HIMAGELIST hilDragOrg;

public:

	MButtonPan(WindowWithHScrollBar *pWnd, DWORD _dwPeriod, DWORD _dwID);
	MButtonPan(WindowWithVScrollBar *pWnd, DWORD _dwPeriod, DWORD _dwID);
	MButtonPan(WindowWithBothScrollBars *pWnd, DWORD _dwPeriod, DWORD _dwID);
	~MButtonPan();

	void start(POINT cursor);
	void stop();
	bool handle_mousemove(POINT cursor);
	bool handle_timer(DWORD _dwID);

};






///////////////////////////////////////////////////////////////////////////////

#endif // _SCRBAR_



