
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_select.cpp
//

#include <stdio.h>
#include "id.h"
#include "sprite_select.h"


LPCSTR SpriteSelectDialog::get_template() const{
	return "SPRITE_SELECT";
}



BOOL SpriteSelectDialog::Proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg){
		case WM_INITDIALOG:
			{
				char s[128];
				char sprite_name[256];
				char n[8];
				int sprite_count = GetPrivateProfileInt("Sprites", "Count", 206, SpriteInfoFileName);
				HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
				for (int i=0; i<sprite_count; i++){
					sprintf_s(n, sizeof n, "%04X", i*2);
					GetPrivateProfileString("SpriteName", n, "?",
						sprite_name, sizeof sprite_name, SpriteInfoFileName);
					sprintf_s(s, sizeof s, "%s: %s", n, sprite_name);
					SendMessage(hwList, LB_INSERTSTRING, (WPARAM)i, (LPARAM)s);
				}
				SendMessage(hwList, LB_SETCURSEL, (WPARAM)lParam/2, (LPARAM)0);
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case IDC_LIST0:
					if (HIWORD(wParam) == LBN_DBLCLK){
						SendMessage(hWnd, WM_COMMAND, IDOK, (LPARAM)0);
						return TRUE;
					}
					return FALSE;
				case IDOK:
					{
						int sprite_num = SendDlgItemMessage(hWnd, IDC_LIST0, LB_GETCURSEL, 0, 0) * 2;
						EndDialog(hWnd, (INT_PTR)sprite_num);
					}
					return TRUE;
				case IDCANCEL:
					EndDialog(hWnd, (INT_PTR)-1);
					return TRUE;
			}
			return FALSE;
	}
	return FALSE;
}






